<?php

require('sqlcached_client.php');
    
if (count($argv) > 1) {
    /* use command-line specified connection url */
    $sq = new SQLCacheD_Client($argv[1]);
} else
    $sq = new SQLCacheD_Client();

try {
    $sq->query("DROP TABLE test");
    echo "Dropped table TEST\n";
} catch (SQLCacheD_Exception $e) {}


$sq->query("CREATE TABLE test (
    id      INTEGER PRIMARY KEY,
    time    INTEGER,
    rand    INTEGER,
    name    VARCHAR)");

$sq->set_expiry("test", 60);

$time = time();
$rand = rand(0, 0xffff);
if (!$sq->query("INSERT INTO test(time,rand,name) VALUES($time, $rand, 'Žagi')"))
    die("Error in INSERT");
$rand = rand(0, 0xffff);
if (!$sq->query("INSERT INTO test(time,rand,name) VALUES($time, $rand, 'Madagaskar')"))
    die("Error in INSERT");

$res = $sq->query("SELECT * FROM test");
var_dump($res);

if (count($res) != 2)
    die("Invalid data returned");

$sq->set_expiry_ops_interval("test", 0);
$sq->set_expiry("test", 2);

sleep(3);
$sq->get_ver(); // dummy op - expiry check happens AFTER execution of an op

$res = $sq->query("SELECT * FROM test");
if ($res !== 0)
    die("Time-based expiry doesn't work");

$time = time();
$sq->set_expiry_ops_interval("test", 100);
$sq->set_expiry("test", 0, 50);
for ($i = 0; $i < 50; $i++) {
    $rand = rand(0, 0xffff);
    $sq->query("INSERT INTO test(time,rand,name) VALUES($time, $rand, 'Record #$i')");
}
$res = $sq->query("SELECT id FROM test");
echo "At start there are ". count($res)." records\n";
$time++;
for ($i = 0; $i < 50; $i++) {
    $rand = rand(0, 0xffff);
    $sq->query("INSERT INTO test(time,rand,name) VALUES($time, $rand, 'Additional Record #$i')");
}
$res = $sq->query("SELECT id FROM test");
echo "At the end there are ". count($res)." records\n";



?>
