<?php
require('sqlcached_client.php');

function time_float() {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}


$time = time();

$sc = new SQLCacheD_Client();

$sc->query("DELETE FROM cache");

$sc->query("INSERT INTO cache(key, value, time) VALUES ('a key', 'some value', $time)");

$rs = $sc->query("SELECT * FROM cache");
var_dump($rs);

$count = 100000;
echo "\nTiming $count inserts...\n";

$time1 = time_float();
for ($i = 0; $i < $count; $i++) {
    $sc->query("INSERT INTO cache(key, value, time) VALUES ('key$i', 'value $i', $time)");
}
$time2 = time_float();
$qps = $count / ($time2 - $time1);
$qps = sprintf("%0.1f", $qps);
echo "Queries per second: $qps\n";

echo "\nTiming $count selects...\n";

$time1 = time_float();
for ($i = 0; $i < $count; $i++) {
    $c = rand(0, $count-1);
    $rs = $sc->query("SELECT value FROM cache WHERE key='key$c'");
    if (count($rs) != 1)
        throw new Exception("Uh oh");
}
$time2 = time_float();
$qps = $count / ($time2 - $time1);
$qps = sprintf("%0.1f", $qps);
echo "Queries per second: $qps\n";


?>
