<?php
require('sqlcached_client.php');

$sc = new SQLiteDatabase("x:memory:");

$sc->query("CREATE TABLE cache(
    key     varchar not null primary key,
    value   varchar not null,
    time    integer not null
)");
$sc->query("CREATE INDEX cache_time ON cache(time)");

//$sc->query("DELETE FROM cache");

//$sc->query("INSERT INTO cache(key, value, time) VALUES ('a key', 'some value', $time)");
/*
$rs = $sc->query("SELECT * FROM cache", SQLITE_ASSOC);
$rows = $rs->fetchAll();
var_dump($rows);
*/
$count = 100000;
echo "\nTiming $count inserts...\n";

$time = $time1 = time();
for ($i = 0; $i < $count; $i++) {
    if (!$sc->query("INSERT INTO cache(key, value, time) VALUES ('key$i', 'value $i', $time)"))
        throw new Exception("Error");
}
$time2 = time();
$qps = $count / ($time2 - $time1);
$qps = sprintf("%0.1f", $qps);
echo "Queries per second: $qps\n";

echo "\nTiming $count selects...\n";

$time1 = time();
for ($i = 0; $i < $count; $i++) {
    $c = rand(0, $count-1);
    $rs = $sc->query("SELECT value FROM cache WHERE key='key$c'", SQLITE_ASSOC);
    $rs->fetchAll();
    if ($rs->numRows() != 1)
        throw new Exception("Uh oh");
}
$time2 = time();
$qps = $count / ($time2 - $time1);
echo "Queries per second: $qps\n";


?>
