/*-
 * Copyright (c) 2006. Ivan Voras <ivoras@gmail.com>
 * Released under the Artistic License
 */

/*
 * sqlcached common definitions
 * $Id: common.h,v 1.4 2006/05/12 23:32:28 ivoras Exp $
 */

#define SC_CMD_LEN 3

#ifdef SQLCACHED_SERVER

enum E_SC_STATE { E_SC_START, E_SC_CMD_CHAR, E_SC_CMD_SPACE, E_SC_PARAM_CHAR,
    E_SC_EOL, E_SC_EAT_EOL };

enum E_SC_TYPE { SC_CONN_TYPE_NO, SC_CONN_TYPE_CLIENT_UNIX, SC_CONN_TYPE_CLIENT_TCP,
    SC_CONN_TYPE_SERVER_UNIX, SC_CONN_TYPE_SERVER_TCP };

enum E_SC_FLAG { SC_CLOSE_ON_DONE_WRITING = 1, SC_ESCAPE = 2 };

struct sc_conn {
    enum E_SC_TYPE type;        /* type of this sc_conn node */
    int socket;
    union {
        struct sockaddr_in sin;
        struct sockaddr_un sun;
    };
    enum E_SC_FLAG flags;
    enum E_SC_STATE pstate;     /* parser automata state */
    char cmd[SC_CMD_LEN+1];     /* parsed cmd */
    unsigned int cmd_pos;
    char *param;                /* command argument buffer */
    unsigned int param_len;
    unsigned int param_size;
    char *outbuf;               /* data to send to client */
    unsigned int outbuf_len;
    unsigned int outbuf_size;
};

struct sc_expiry {
    char table_name[100];
    unsigned int limit_ops;     /* ops = any db operation */
    unsigned int next_ops;
    unsigned int limit_time;    /* time = specific for this table */
    unsigned int last_time;
    unsigned int next_time;
    unsigned int limit_records; /* limit table record count */
    unsigned int last_rowid;
};

void sc_add_char(struct sc_conn *sconn, char* ch, ssize_t size);
void sc_destroy_conn(struct sc_conn *sconn);
void sc_check_expiry();

#endif

#define DEFAULT_UNIX_SOCKET "/tmp/sqlcached.sock"
#define SC_VER_SIG "sqlcached-1"

