/*-
 * Copyright (c) 2006. Ivan Voras <ivoras@gmail.com>
 * Released under the Artistic License
 */

/*
 * sqlcached C client header file
 * $Id: sqlcached_client.h,v 1.2 2006/04/30 22:31:48 ivoras Exp $
 */

struct sc_client_conn {
    int sock_server;
    FILE *server;
};

struct sc_result_set {
    unsigned int n_rows;
    unsigned int n_cols;
    char **names;           /* column names */
    char ***rows;           /* rows/records */
};

enum SC_RESULT { SC_OK, SC_ERROR, SC_HANDSHAKE_ERROR, SC_SIG_ERROR, 
    SC_NET_ERROR, SC_SQL_ERROR };

int sc_connect_unix(char *unix_socket_name, struct sc_client_conn *sc, char **errormsg);
int sc_get_ver(struct sc_client_conn *sc, char *ver);
int sc_exec_query(struct sc_client_conn *sc, char *sql, struct sc_result_set *rs, char **errormsg);
void sc_free_result(struct sc_client_conn *sc, struct sc_result_set *rs);


