#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sqlite3.h>


int main(int argc, char** argv) {
    int i, count, t, time1, time2;
    sqlite3 *db;
    char *msg;
    char sql[200];

    if (sqlite3_open("y:memory:", &db) != 0) {
        fprintf(stderr, "Error: %s\n", sqlite3_errmsg(db));
        exit(1);
    }

    sqlite3_exec(db, "CREATE TABLE cache (key varchar not null, value varchar not null, time integer not null, primary key(key))", NULL, NULL, NULL);
    sqlite3_exec(db, "CREATE INDEX cache_time ON cache(time)", NULL, NULL, NULL);

    count = 10000;

    t = time1 = time(NULL);
    for (i = 0; i < count; i++) {
        sprintf(sql, "INSERT INTO cache(key, value, time) VALUES ('key%d', 'value %d', %d)", i, i, i);
        if (sqlite3_exec(db, sql, NULL, NULL, &msg) != SQLITE_OK) {
            fprintf(stderr, "sqlite error %s\n", msg);
            exit(1);
        }
    }
    time2 = time(NULL);

    printf("%0.1f qps\n", (float)count / (time2-time1));
    return 0;
}
