#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>

#include <sqlite.h>

static double time_float() {
    struct timeval tv;
    gettimeofday(&tv, NULL);
    return tv.tv_sec + (double)tv.tv_usec / 1000000.0;
}


int main(int argc, char** argv) {
    int i, count, t;
    double time1, time2;
    sqlite *db;
    char *msg;
    char sql[200];

    if ((db = sqlite_open(":memory:", 0666, &msg)) == NULL) {
        fprintf(stderr, "Error: %s\n", msg);
        exit(1);
    }

    sqlite_exec(db, "CREATE TABLE cache (key varchar not null, value varchar not null, time integer not null, primary key(key))", NULL, NULL, NULL);
    sqlite_exec(db, "CREATE INDEX cache_time ON cache(time)", NULL, NULL, NULL);

    count = 100000;

    printf("Timing %d INSERTs...\n", count);
    t = time(NULL);
    time1 = time_float();
    for (i = 0; i < count; i++) {
        sprintf(sql, "INSERT INTO cache(key, value, time) VALUES ('key%d', 'value %d', %d)", i, i, t);
        if (sqlite_exec(db, sql, NULL, NULL, &msg) != SQLITE_OK) {
            fprintf(stderr, "sqlite error %s\n", msg);
            exit(1);
        }
    }
    time2 = time_float();
    printf("%0.1f qps\n", (float)(count / (time2-time1)));


    printf("Timing %d SELECTs...\n", count);
    time1 = time_float();
    for (i = 0; i < count; i++) {
        sprintf(sql, "SELECT value FROM cache WHERE key='key%d'", i);
        if (sqlite_exec(db, sql, NULL, NULL, &msg) != SQLITE_OK) {
            fprintf(stderr, "sqlite error %s\n", msg);
            exit(1);
        }
    }
    time2 = time_float();
    printf("%0.1f qps\n", (float)(count / (time2-time1)));


    return 0;
}
